<?php

namespace Modules\Pp\Http\Controllers;

use App\Http\Controllers\MailController;
use App\Http\Controllers\OrderStatusHistoryController;
use App\Mail\MailData;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Pd\Entities\ProductionStatus;
use Modules\Pp\Entities\CustomerOrder;
use Modules\Pp\Entities\CustomerOrderData;
use Modules\Pp\Entities\CustomerPlan;
use Modules\Pp\Entities\CustomerPlanData;
use Modules\Pp\Entities\OrderStatus;
use Modules\Sd\Entities\ShippingStatus;
use Modules\St\Entities\Country;

class CustomerOrderAcceptListController extends Controller
{
    protected $quarantin_email_group = 2;

    public function allCustomerOrder()
    {
        try {
            $customer_orders = CustomerOrder::orderBy('order_id', 'DESC')->get();
            foreach ($customer_orders as $order) {
                $plan = CustomerPlan::where('order_id', '=', $order->order_id)->first();
                if ($plan) {
                    $order->isAllowcated = 1;
                } else {
                    $order->isAllowcated = 0;
                }
            }

            $responseBody = $this->responseBody(true, "CustomerOrderListController", "allCustomerOrder", $customer_orders);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "allCustomerOrder", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function new_order_staus(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->order_status = 0;
                if ($customer_order->update()) {
                    OrderStatusHistoryController::changeOrderStatus($customer_order); 
                }
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "status", 'New status');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }

    public function accept(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->order_status = 1;
                if ($customer_order->update()) {

                    if ($this->isQuarantineCertificate($customer_order->country_id) == 1) {
                        $recievers = MailData::getRecievers($this->quarantin_email_group);
                        foreach ($recievers as $address) {
                            $order = CustomerOrder::find($id);
                            $subject = "Quarantine Certificate";

                            $email_body = "Customer PO No : " . $order->purchase_order;
                            $email_body .= "<br> Factory PO No : " . $order->factory_po_num;
                            $email_body .= "<br> Quarantine Certificate ";
                            if ($order) {
                                MailController::createMail($subject, $email_body, MailData::getSender(), $address);
                            }
                        }
                    }
                    OrderStatusHistoryController::changeOrderStatus($customer_order);
                }
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "status", 'Accepted');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function revice(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->order_status = 2;
                if($customer_order->update()){
                    OrderStatusHistoryController::changeOrderStatus($customer_order);
                }
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "status", 'Reviced');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function reject(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->order_status = 3;
                if($customer_order->update()){
                    OrderStatusHistoryController::changeOrderStatus($customer_order);
                }            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "status", 'Rejected');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function proceed(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->order_status = 4;
                if($customer_order->update()){
                    OrderStatusHistoryController::changeOrderStatus($customer_order);
                }
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "status", 'proceed');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function hold(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->order_status = 5;
                if($customer_order->update()){
                    OrderStatusHistoryController::changeOrderStatus($customer_order);
                } 
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "status", 'Hold');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function fund_status_yes(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->fund_status = 1;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "fund status", 'Yes');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function fund_status_no(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->fund_status = 0;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "fund status", 'No');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function production_status_new(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 0;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'New');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function production_status_planed(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 1;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'Planed');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function production_status_scheduled(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 2;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'Schedulede');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function production_status_start(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 3;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'Start');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function production_status_hold(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 4;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'Hold');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function production_status_finished(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 5;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'Finished');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function production_status_delivered(Request $request)
    {
        try {

            $id = $request->get('id');
            $customer_order = CustomerOrder::find($id);
            if ($customer_order) {
                $customer_order->production_status = 6;
                $customer_order->update();
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "production status", 'Delivered');
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function checkProductionStatus($id)
    {
        try {

            $customer_order = CustomerOrder::find($id);
            $status = 0;
            if ($customer_order) {
                $status = $customer_order->production_status;
            }
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "checkProductionStatus", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderAcceptListController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getProductionStatus()
    {
        try {

            $status = ProductionStatus::all();
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "getProductionStatus", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderAcceptListController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getOrderStatus()
    {
        try {

            $status = OrderStatus::all();
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "getOrderStatus", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderAcceptListController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getShippingStatus()
    {
        try {

            $status = ShippingStatus::all();
            $responseBody = $this->responseBody(true, "CustomerOrderAcceptListController", "getShippingStatus", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderAcceptListController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    private function isQuarantineCertificate($country_id)
    {
        $country = Country::find($country_id);
        if ($country) {
            return $country->quarantine_certificate;
        }
        return 0;
    }




    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
